package com.gxzc.zen.api.sys.service

import com.baomidou.mybatisplus.plugins.Page
import com.gxzc.zen.api.sys.model.SysUser
import com.gxzc.zen.common.base.BaseService

/**
 * <p>
 * 用户管理 服务类
 * </p>
 *
 * @author NorthLan123
 * @since 2018-02-06
 */
interface ISysUserService : BaseService<SysUser> {

    fun getUserByAccount(account: String): SysUser?

    /**
     * 获取用户列表(分页)
     */
    fun getUserListPage(keyword: String?, searchOption: Int?, page: Page<SysUser>, enable: Boolean?): Page<SysUser>

    /**
     * 获取用户列表
     */
    fun getUserList(keyword: String?, searchOption: Int?, enable: Boolean?): MutableList<SysUser>

    /**
     * 注册
     */
    fun register(entity: SysUser): SysUser

    /**
     * 修改用户信息
     * 如果 entity 中密码不为空 则表示修改密码
     */
    fun modify(entity: SysUser): SysUser

    /**
     * 删除用户
     * 物理删除
     */
    fun delete(id: Long)

//    /**
//     * 查询用户列表
//     * 缓存
//     */
//    fun getListCacheable(): MutableList<SysUser>
//
//    /**
//     * 通过 id 查询用户
//     * 缓存
//     */
//    fun getUserByIdCacheable(id: Long): SysUser?
//
//    /**
//     * 通过 account 查询用户
//     * 缓存
//     */
//    fun getUserByAccountCacheable(account: String): SysUser?
//
//    /**
//     * 插入并缓存
//     */
//    fun insertCacheable(entity: SysUser)
//
//    /**
//     * 修改 并 更新缓存
//     */
//    fun modify(entity: SysUser): SysUser
//
//    /**
//     * 物理删除
//     * 刷新缓存
//     */
//    fun physicalDeleteCacheable(id: Long)
}
